﻿using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Filters;
using Microsoft.AspNetCore.Routing;

namespace TestProject
{
    /// <summary>
    /// 세션 체크 액션 필터 어트리뷰트
    /// </summary>
    public class SessionCheckActionFilterAttribute : ActionFilterAttribute
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 액션 실행시 처리하기 - OnActionExecuting(context)

        /// <summary>
        /// 액션 실행시 처리하기
        /// </summary>
        /// <param name="context">컨텍스트</param>
        public override void OnActionExecuting(ActionExecutingContext context)
        {
            if(context.HttpContext.Session.GetString("Name") == null)
            {
                context.Result = new RedirectToRouteResult
                (
                    new RouteValueDictionary
                    (
                        new
                        {
                            action     = "Index",
                            controller = "Home"
                        }
                    )
                );
            }

            base.OnActionExecuting(context);
        }

        #endregion
    }
}